---
title: WebSocket()
slug: Web/API/WebSocket/WebSocket
tags:
  - API
  - Constructor
  - Reference
  - Web API
  - WebSocket
---
<p>{{APIRef("Web Sockets API")}}</p>

<p>The <code><strong>WebSocket()</strong></code> constructor returns a new {{domxref("WebSocket")}} object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>aWebSocket</em> = new WebSocket(<em>url</em> [, protocols]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>url</code></dt>
 <dd>The URL to which to connect; this should be the URL to which the WebSocket server will respond.</dd>
 <dt><code>protocols</code> {{optional_inline}}</dt>
 <dd>Either a single protocol string or an array of protocol strings. These strings are used to indicate sub-protocols, so that a single server can implement multiple WebSocket sub-protocols (for example, you might want one server to be able to handle different types of interactions depending on the specified <code>protocol</code>).</dd>
 <dd>If it is omitted, an empty array is used by default, i.e. <code>[]</code>.</dd>
</dl>

<h3 id="Exceptions_thrown">Exceptions thrown</h3>

<dl>
 <dt><code>SECURITY_ERR</code></dt>
 <dd>The port to which the connection is being attempted is being blocked.</dd>
 <dt><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/SyntaxError">SyntaxError</a></dt>
 <dd>The URL is invalid.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-websocket', 'the WebSocket constructor')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WebSocket.WebSocket")}}</p>
